[![Gitpod Ready-to-Code](https://img.shields.io/badge/Gitpod-Ready--to--Code-blue?logo=gitpod)][gitpod]
[![Pipeline Status](https://gitlab.stud.idi.ntnu.no/it1901/students-2021/oysteikt/badges/master/pipeline.svg)][pipeline]
[![Coverage](https://gitlab.stud.idi.ntnu.no/it1901/students-2021/oysteikt/badges/master/coverage.svg)][coverage]

# Javafx template

A repository with ~~three~~ `one` variants of a javafx projects, with maven setup for Java 16 and JavaFX 16, and JUnit 5 (Jupiter) and TestFX for testing.

To make the project(s) more interesting, it is the start of an [RPN][rpn] calculator (look for `// TODO`) markers). The core logic is almost implemented (in [Calc.java][calc.java]), the fxml file (in [Calc.fxml][calc.fxml] is almost complete, but the controller class (in [CalcController.java][calc_controller.java] is pretty limited. And last, but not least, there is a TestFX-based test (in [CalcAppTest.java][calc_app_test.java], see the [README][readme] for details about what it tests).

## Trying it out

All projects can be tried out by cd-ing into the corresponding folder and using `mvn`:

- compile with `mvn compile` (after `cd oysteikt-calc` of course)
- test with `mvn test` (it should fail until you complete the RPN calculator)
- run with `mvn javafx:run` (it should open, but not work properly)

[gitpod]: https://gitpod.stud.ntnu.no/#https://gitlab.stud.idi.ntnu.no/it1901/students-2021/oysteikt
[pipeline]: https://gitlab.stud.idi.ntnu.no/it1901/students-2021/oysteikt/-/pipelines
[coverage]: https://it1901.pages.stud.idi.ntnu.no/students-2021/oysteikt/

[rpn]: https://en.wikipedia.org/wiki/Reverse_Polish_notation

[calc.java]:            oysteikt-calc/src/main/java/app/Calc.java
[calc.fxml]:            oysteikt-calc/src/main/resources/app/Calc.fxml
[calc_controller.java]: oysteikt-calc/src/main/java/app/CalcController.java
[calc_app_test.java]:   oysteikt-calc/src/test/java/app/CalcAppTest.java
[readme]:               oysteikt-calc/src/test/java/app/README.md